##############################################################################
#
# Copyright (c) 2005 Tino Wildenhain.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################
""" Patch for Python Script TracebackSuppement

    This method handles the code excerpt with linenumbers and
    marking of the offending current line.

"""

def getInfo(self,as_html=0):
    lines=self.object.body().split("\n")

    return "\n"+"\n".join(["%03d%s|%s" % (i,((i+1)==self.line) and ">" or " ",lines[i])
                          for i in range(max(0,self.line-3),min(self.line+2,len(lines)))])
